// forward-button

function updateForwardButtonMenu(event)
{
  var forwardType = 0;
  var forwardInlineMenuItem = document.getElementById("button-forwardAsMenu-forwardInline");
  var forwardAsAttachmentMenuItem = document.getElementById("button-forwardAsMenu-forwardAsAttachment");

  if (forwardInlineMenuItem) forwardInlineMenuItem.setAttribute("default", "false");
  if (forwardAsAttachmentMenuItem) forwardAsAttachmentMenuItem.setAttribute("default", "false");

  try {
    forwardType = gPrefBranch.getIntPref("mail.forward_message_mode");
  }
  catch (ex) {
    dump("failed to retrieve pref mail.forward_message_mode");
  }

  // mail.forward_message_mode could be 1, if the user migrated from 4.x
  // 1 (forward as quoted) is obsolete, so we treat is as forward inline
  // since that is more like forward as quoted then forward as attachment
  if (forwardType == 0) {
    if (forwardAsAttachmentMenuItem) forwardAsAttachmentMenuItem.setAttribute("default", "true");
  } else {
    if (forwardInlineMenuItem) forwardInlineMenuItem.setAttribute("default", "true");
  }  
}

// Hightlight default forward mode
window.addEventListener("load", updateForwardButtonMenu, false);

var myPrefObserver =
{
  register: function()
  {
    var prefService = Components.classes["@mozilla.org/preferences-service;1"]
                                .getService(Components.interfaces.nsIPrefService);
    this._branch = prefService.getBranch("mail.forward_message_mode");
    this._branch.QueryInterface(Components.interfaces.nsIPrefBranch2);
    this._branch.addObserver("", this, false);
  },

  unregister: function()
  {
    if(!this._branch) return;
    this._branch.removeObserver("", this);
  },

  observe: function(aSubject, aTopic, aData)
  {
    if(aTopic != "nsPref:changed") return;
    updateForwardButtonMenu();
  }
}

// Watch for preference changes
myPrefObserver.register();

// threadPane and messagePane menu menuitem

function SetupForwardAsMenuMenuItem(menuID, numSelected, forceHide)
{
  ShowMenuItem(menuID, (numSelected <= 1) && !forceHide);
  EnableMenuItem(menuID, (numSelected == 1));
}

// threadPane

function forward_fillThreadPaneContextMenu()
{
  var numSelected = GetNumSelectedMessages();
  SetupForwardAsMenuMenuItem("threadPaneContext-forwardAsMenu", numSelected, false);
}

// messagePane

function forward_fillMessagePaneContextMenu()
{
  var message = GetLoadedMessage();
  var numSelected = (message) ? 1 : 0;

  // don't show mail items for links/images, just show related items.
  var hideMailItems = gContextMenu.onImage || gContextMenu.onLink;
  SetupForwardAsMenuMenuItem("messagePaneContext-forwardAsMenu", numSelected, (numSelected == 0 || hideMailItems));
}

function installListeners(event)
{
  var el;
  el = document.getElementById("threadPaneContext");
  if (el) el.addEventListener("popupshowing", forward_fillThreadPaneContextMenu, false);

  el = document.getElementById("messagePaneContext");
  if (el) el.addEventListener("popupshowing", forward_fillMessagePaneContextMenu, false);
}

function uninstallListeners(event)
{
  var el;
  el = document.getElementById("threadPaneContext");
  if (el) el.removeEventListener("popupshowing", forward_fillThreadPaneContextMenu, false);

  el = document.getElementById("messagePaneContext");
  if (el) el.removeEventListener("popupshowing", forward_fillMessagePaneContextMenu, false);
}

window.addEventListener("load", installListeners, false);
window.addEventListener("unload", uninstallListeners, false);
